## cwebx 3.04

=== Makefile ===
# This file is part of CWEB, version x3.0.

# 
# Read the README file, then edit this file to reflect local conditions
#

# The C compiler should be ANSI compatible

CC = gcc

# We let CWEAVE report syntax errors by setting +d.
# The flag +m makes the TeX output slightly more compact.
# We use the +e flag since our printer is two-sided.

CWFLAGS = +mde
CTFLAGS =

# We keep debugging info around to enable the `+d' option of cweave
CFLAGS = -DDEBUG -DSTAT -g

# RM and CP are used below in case rm and cp are aliased

RM= /bin/rm
CP= /bin/cp
RENAME= /bin/mv


# Set CCHANGES to common-foo.ch if you need changes to common.w in another
# file than common.ch

CCHANGES=

# Set TCHANGES to ctangle-foo.ch if you need changes to ctangle.w in another
# file than ctangle.ch

TCHANGES=

# Set WCHANGES to cweave-foo.ch if you need changes to cweave.w in another
# file than cweave.ch

WCHANGES=

##########  You shouldn't have to change anything after this point #######

CWEAVE = ./cweave $(CWFLAGS)
CTANGLE = ./ctangle $(CTFLAGS)

.SUFFIXES: .tex .dvi .w

.w.tex:
	$(CWEAVE) $*

.tex.dvi:
	tex $*.tex

.w.c:
	$(CTANGLE) $*

.w.dvi:
	make $*.tex
	make $*.dvi

.w.o:
	make $*.c
	make $*.o

all: cweb doc listings
cweb: ctangle cweave
manual doc: manual.dvi
listings: common.dvi ctangle.dvi cweave.dvi

cautiously:
	make common.c ctangle.c cweave.c
	$(RENAME) ctangle SAVEctangle # save version in case things mess up
	make ctangle
	$(RENAME) common.c SAVEcommon.c
	./ctangle common $(CCHANGES)
	diff common.c SAVEcommon.c
	$(RENAME) SAVEcommon.c common.c # restore date
	$(RENAME) ctangle.c SAVEctangle.c
	./ctangle ctangle $(TCHANGES)
	diff ctangle.c SAVEctangle.c
	$(RENAME) SAVEctangle.c ctangle.c # restore date
	$(RENAME) cweave.c SAVEcweave.c
	./ctangle cweave $(WCHANGES)
	diff cweave.c SAVEcweave.c
	$(RENAME) SAVEcweave.c cweave.c # restore date
	$(RM) SAVEctangle # succeeded, use new binary from now on

SAVEctangle.c:
	$(CP) ctangle.c SAVEctangle.c

SAVEcommon.c:
	$(CP) common.c SAVEcommon.c

common.c: common.w $(CCHANGES) common.inc
	$(CTANGLE) common $(CCHANGES)
common.h: common.w $(CCHANGES)
	$(CTANGLE) common $(CCHANGES)

common.tex:  common.w common.inc
	$(CWEAVE) common $(CCHANGES)

ctangle: ctangle.o common.o
	$(CC) $(CFLAGS) -o ctangle ctangle.o common.o 

ctangle.c: ctangle.w $(TCHANGES) common.inc common.h
	$(CTANGLE) ctangle $(TCHANGES)

ctangle.tex:  ctangle.w $(TCHANGES) common.inc intro.inc
	$(CWEAVE) ctangle $(TCHANGES)

cweave: cweave.o common.o
	$(CC) $(CFLAGS) -o cweave cweave.o common.o

cweave.c: cweave.w $(WCHANGES) common.inc common.h parser.w rules.w
	$(CTANGLE) cweave $(WCHANGES)

cweave.tex:  cweave.w $(WCHANGES) parser.w rules.w common.inc intro.inc
	$(CWEAVE) cweave $(WCHANGES)

manual.dvi: compare.tex

## cwebx 3.52

=== Makefile ===
# This file is part of CWEB, version x3.51 (or newer)

#
# Read the README file, then edit this file to reflect local conditions
#

# In whose 'bin/' subdirectory the 'install' target will put the binaries
# If you cannot write to /usr/local, replace it by your home directory
# And make sure $(prefix)/bin is in your PATH
prefix = /usr/local

# The C compiler should be ANSI compatible. If you change this to another
# brand then gcc, make sure you also change the -ansi flag in CFLAGS below to
# one that tells your compiler to expect only strict ANSI/ISO C source code.
# If you don't, then your compiler might squirm about identifiers that it
# predeclares without us having asked it to, and which conflict with the
# identifiers actually used in the CWEBx source, which then fails to compile.
CC = gcc

# Command line flags for CTANGLE and CWEAVE while building CWEB
# We let CWEAVE report syntax errors by setting +d.
# The flag +m makes the TeX output slightly more compact.
# We use the +e flag since our printer is two-sided.

CTFLAGS =
CWFLAGS = +mde

# The -ansi flag (for gcc) should guard against spurious #include files
# We keep debugging info around to enable the `+d' option of cweave
CFLAGS = -ansi -DSTAT

# RM and CP are used below in case rm and cp are aliased

RM= /bin/rm -f
CP= /bin/cp -p
RENAME= /bin/mv


# Set CCHANGES to common-foo.ch if you need changes to common.w in another
# file than common.ch

CCHANGES=

# Set TCHANGES to ctangle-foo.ch if you need changes to ctangle.w in another
# file than ctangle.ch

TCHANGES=

# Set WCHANGES to cweave-foo.ch if you need changes to cweave.w in another
# file than cweave.ch

WCHANGES=

##########  You shouldn't have to change anything after this point #######

CWEAVE = ./cweavex $(CWFLAGS)
CTANGLE = ./ctanglex $(CTFLAGS)


.SUFFIXES:
.SUFFIXES: .w .c .o .tex .dvi

.w.tex:
	$(CWEAVE) $*

.tex.dvi:
	$(TEX) $*.tex

.w.c:
	$(CTANGLE) $*

.c.o:
	$(CC) -c $(CPPFLAGS) $(CFLAGS) $< -o $@

.PHONY: all cweb manual doc listings cautiously
all: cweb doc listings
cweb: ctanglex cweavex
manual doc: manual.dvi
listings: common.dvi ctangle.dvi cweave.dvi

cautiously: common.c ctangle.c cweave.c
	$(RENAME) ctanglex SAVEctangle # save version in case things mess up
	$(MAKE) ctanglex
	$(RENAME) common.c SAVEcommon.c
	./ctanglex common $(CCHANGES)
	diff common.c SAVEcommon.c
	$(RENAME) SAVEcommon.c common.c # restore date
	$(RENAME) ctangle.c SAVEctangle.c
	./ctanglex ctangle $(TCHANGES)
	diff ctangle.c SAVEctangle.c
	$(RENAME) SAVEctangle.c ctangle.c # restore date
	$(RENAME) cweave.c SAVEcweave.c
	./ctanglex cweave $(WCHANGES)
	diff cweave.c SAVEcweave.c
	$(RENAME) SAVEcweave.c cweave.c # restore date
	$(RM) SAVEctangle # succeeded, use new binary from now on

SAVEctangle.c:
	$(CP) ctangle.c SAVEctangle.c

SAVEcommon.c:
	$(CP) common.c SAVEcommon.c

common.c: common.w $(CCHANGES) common.inc
	$(CTANGLE) common $(CCHANGES)
common.h: common.w $(CCHANGES)
	$(CTANGLE) common $(CCHANGES)

common.tex:  common.w common.inc
	$(CWEAVE) common $(CCHANGES)

ctanglex: ctangle.o common.o
	$(CC) $(CFLAGS) -o ctanglex ctangle.o common.o

ctangle.c: ctangle.w $(TCHANGES) common.inc common.h
	$(CTANGLE) ctangle $(TCHANGES)

ctangle.tex:  ctangle.w $(TCHANGES) common.inc intro.inc
	$(CWEAVE) ctangle $(TCHANGES)

cweavex: cweave.o common.o
	$(CC) $(CFLAGS) -o cweavex cweave.o common.o

cweave.c: cweave.w $(WCHANGES) common.inc common.h parser.w rules.w
	$(CTANGLE) cweave $(WCHANGES)

cweave.tex:  cweave.w $(WCHANGES) parser.w rules.w common.inc intro.inc
	$(CWEAVE) cweave $(WCHANGES)

manual.dvi: compare.tex

.PHONY:	mostlyclean clean install check

mostlyclean:
	$(RM) *~ *.o *.log *.toc
	$(RM) common.tex ctangle.tex cweave.c cweave.tex

clean:	mostlyclean
	$(RM) *.dvi ctanglex cweavex

install: ctanglex cweavex
	test -s $(prefix)/bin || mkdir $(prefix)/bin
	$(CP) ctanglex cweavex $(prefix)/bin

check:
	@echo 'Did you expect a check from me?'

=== examples/Makefile ===
CFLAGS = 
CWEAVE = cweave +d
CTANGLE = ctangle
.SUFFIXES: .tex .dvi .w

.w.tex:
	$(CWEAVE) $*

.tex.dvi:	
	tex $*


.w.dvi:
	$(CWEAVE) $*
	tex $*

.w.c:
	$(CTANGLE) $*

.w.o:
	$(CTANGLE) $*
	$(CC) $(CFLAGS) -c $*.c

.w.dvi:
	make $*.tex
	make $*.dvi

.w.o:
	make $*.c
	make $*.o

treeprint: treeprint.w
	make treeprint.c
	make treeprint	

wc: wc.w
	make wc.c
	make wc

wmerge: wmerge.w
	make wmerge.o
	$(CC) $(CFLAGS) -o wmerge wmerge.o ../common.o

=== debian/changelog ===
cwebx (3.52-4) unstable; urgency=medium

  [ Debian Janitor ]
  * Use canonical URL in Vcs-Browser.
  * Update standards version to 4.6.1, no changes needed.

  [ Julian Gilbey ]
  * Update standards version to 4.7.2, no changes needed.

 -- Julian Gilbey <jdg@debian.org>  Tue, 01 Apr 2025 12:21:30 +0100

cwebx (3.52-3) unstable; urgency=medium

  * Install manual in PDF format instead of DVI format
  * Fix examples Makefile
  * Support parallel building
  * Bump Standards-Version
  * Update to current debhelper-compat
  * Update copyright file to new format
  * Add Vcs-Git and Vcs-Browser to debian/control

 -- Julian Gilbey <jdg@debian.org>  Thu, 28 Jan 2021 10:36:52 +0000

cwebx (3.52-2) unstable; urgency=medium

  * Change directory test from test -s to test -d (thanks to Peter Michael
    Green for suggested patch; closes: #772618)

 -- Julian Gilbey <jdg@debian.org>  Thu, 04 Jun 2015 17:48:02 +0100

cwebx (3.52-1) unstable; urgency=medium

  * New upstream release

 -- Julian Gilbey <jdg@debian.org>  Sun, 05 Oct 2014 19:58:02 +0100

cwebx (3.04-9) unstable; urgency=low

  * Update dependencies for new TeXLive packages (Closes: #420904)

 -- Julian Gilbey <jdg@debian.org>  Wed, 25 Apr 2007 14:14:20 +0100

cwebx (3.04-8) unstable; urgency=low

  * Update to new standards version 3.6.2 (Closes: #328794)
  * Update to debhelper version 4

 -- Julian Gilbey <jdg@debian.org>  Tue, 20 Sep 2005 08:44:24 +0100

cwebx (3.04-7) unstable; urgency=low

  * Get debug/warning stuff right this time!

 -- Julian Gilbey <jdg@debian.org>  Tue,  8 May 2001 10:25:40 +0100

cwebx (3.04-6) unstable; urgency=low

  * Support DEB_BUILD_OPTIONS=debug
  * Standards version 3.5.4

 -- Julian Gilbey <jdg@debian.org>  Tue,  8 May 2001 09:25:58 +0100

cwebx (3.04-5) unstable; urgency=low

  * Removed install-stamp from debian/rules
  * Standards version 3.1.1 (FHS, Build-Depends, etc.)

 -- Julian Gilbey <jdg@debian.org>  Tue, 23 Nov 1999 12:34:03 +0000

cwebx (3.04-4) unstable; urgency=low

  * Moved tex input files from /usr/lib/texmf to /usr/share/texmf in line
    with the change in tetex-*, moving towards FHS compliance

 -- Julian Gilbey <jdg@debian.org>  Fri,  9 Apr 1999 12:46:54 +0100

cwebx (3.04-3) unstable; urgency=low

  * Removed CVS files from diff file!

 -- Julian Gilbey <jdg@debian.org>  Thu, 25 Feb 1999 19:55:40 +0000

cwebx (3.04-2) unstable; urgency=low

  * Changed gcc flags to -O2 -g -Wall as described in Policy 4.1

 -- Julian Gilbey <jdg@debian.org>  Sun,  7 Feb 1999 21:34:23 +0000

cwebx (3.04-1) unstable; urgency=low

  * Initial Release.

 -- Julian Gilbey <jdg@debian.org>  Wed, 27 Jan 1999 11:23:23 +0000

=== debian/control ===
Source: cwebx
Section: devel
Priority: optional
Maintainer: Julian Gilbey <jdg@debian.org>
Build-Depends: debhelper-compat (=13), texlive-base
Standards-Version: 4.7.2
Homepage: http://www-math.univ-poitiers.fr/~maavl/CWEBx/
Vcs-Git: https://salsa.debian.org/debian/cwebx.git
Vcs-Browser: https://salsa.debian.org/debian/cwebx

Package: cwebx
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: gcc | c-compiler, texlive-base
Description: C/C++ literate programming system (Marc van Leeuwen's version)
 CWEBx is a complete rewrite of Levy & Knuth's version of CWEB.
 It uses a slightly different syntax from the L&K version, but provides a
 compatibility mode allowing L&K CWEB sources to be processed, producing
 similar (though not necessarily identical) output.
 .
 CWEB allows you to write documents which can be used simultaneously as
 C/C++ programs and as TeX documentation for them.
 .
 The philosophy behind CWEB is that programmers who want to provide the best
 possible documentation for their programs need two things simultaneously: a
 language like TeX for formatting, and a language like C for programming.
 Neither type of language can provide the best documentation by itself.  But
 when both are appropriately combined, we obtain a system that is much more
 useful than either language separately.

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

# There is no configuration step, despite the presence of ./configure
override_dh_auto_configure:

execute_before_dh_auto_build:
	touch ctangle.c
	cp man1/cweb.1 man1/cwebx.1

execute_after_dh_auto_clean:
	rm -f man1/cwebx.1
